local addonName, L = ...;
local function defaultFunc(L, key)
    return key;
end

setmetatable(L, { __index = defaultFunc });

throwAway = {};
CrapTable = {};
NotCrapTable = {};
CrapCount = 0;
NotCrapCount = 0;
GrindLootOptions = {};
GrindLootOptionsTmp = {};

DefaultGrindLootOptions = {};
DefaultGrindLootOptions["Version"] = 25;
DefaultGrindLootOptions["Enabled"] = true;
DefaultGrindLootOptions["GatheringMode"] = false; --loot all mats for all professions
DefaultGrindLootOptions["GatheringModeNoJunk"] = false; --throw away trash on each loot
DefaultGrindLootOptions["LootValuable"] = true;
DefaultGrindLootOptions["MinimumValue"] = 3;
DefaultGrindLootOptions["MinimumRarity"] = 2;
DefaultGrindLootOptions["CloseLootWindow"] = false;
DefaultGrindLootOptions["WhiteList"] = {};
DefaultGrindLootOptions["BlackList"] = {};
DefaultGrindLootOptions["AutoConfirm"] = false;

GrindLootDebug = false;

function GMessage(message)
    DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ff[GrindLoot]|r: " .. message)
end

function print_r(t)
    local print_r_cache = {}
    local maxLevel = 1
    local thisLevel = 0
    local function sub_print_r(t, indent)
        if (print_r_cache[tostring(t)]) then
            print(indent .. "*" .. tostring(t))
        else
            print_r_cache[tostring(t)] = true
            if (type(t) == "table") then
                for pos, val in pairs(t) do
                    if (type(val) == "table") then
                        print(indent .. "[" .. pos .. "] => " .. tostring(t) .. " {")
                        thisLevel=thisLevel+1
                        if(thisLevel<maxLevel)then
                            sub_print_r(val, indent .. string.rep(" ", string.len(pos) + 4))
                            print(indent .. string.rep(" ", string.len(pos) + 2) .. "}")
                        end
                        thisLevel=thisLevel-1
                    elseif (type(val) == "string") then
                        print(indent .. "[" .. pos .. '] => "' .. val .. '"')
                    else
                        print(indent .. "[" .. pos .. "] => " .. tostring(val))
                    end
                end
            else
                print(indent .. tostring(t))
            end
        end
    end

    if (type(t) == "table") then
        print(tostring(t) .. " {")
        sub_print_r(t, " ")
        print("}")
    else
        sub_print_r(t, " ")
    end
    print()
end

local function toboolean(value)
    if value and value ~= "0" and value ~= 0 then
        return true
    end
    return false
end
