GrindLootSettingMixin = CreateFromMixins(SettingMixin);

function GrindLootSettingMixin:Init(name, optKey, variableType)
    if variableType == "boolean" then
        self.ConvertValueInternal = function(self, value)
			return value and (value ~= "0");
        end;
    elseif variableType == "number" then
        self.ConvertValueInternal = function(self, value)
            return tonumber(value);
        end;
    elseif variableType == "string" then
        self.ConvertValueInternal = function(self, value)
            return (value ~= nil) and tostring(value) or "";
        end;
    end

    SettingMixin.Init(self, name, optKey, variableType);

    self.GetValueInternal = function(self)
		if(GrindLootOptions[self.variable] ~= nil)then
			return GrindLootOptions[self.variable];
		else
			return self:ConvertValueInternal(self:GetDefaultValueInternal());
		end
    end;

    self.SetValueInternal = function(self, value)
        self.pendingValue = value;
        GrindLootOptions[self.variable] = value;
        if (self.variable == 'AutoConfirm') then
            if(value)then
                LootSlot = AutoConfirmBoP_LootSlot
            else
                LootSlot = OriginalLoot
            end
        end
        self.pendingValue = nil;

        return value;
    end

    self.GetDefaultValueInternal = function()
        return self.defaultValue;
    end

	self.defaultValue = DefaultGrindLootOptions[self.variable];
end

--

function SetupGrindLootDropDown(category, variable, variableType, options, label, tooltip)
    local setting = RegisterGrindLootSetting(label, variable, variableType);
    local initializer = Settings.CreateDropDown(category, setting, options, tooltip);
    return setting, initializer;
end

function SetupGrindLootCheckBox(category, variable, label, tooltip)
    local setting = RegisterGrindLootSetting(label, variable, "boolean");
    local initializer = Settings.CreateCheckBox(category, setting, tooltip);
    return setting, initializer;
end

function RegisterGrindLootSetting(name, variable, variableType)
    local setting = CreateAndInitFromMixin(GrindLootSettingMixin, name, variable, variableType);
    return setting;
end

